//=============================================================================
// DisplayManager.h
//=============================================================================
#pragma once
#include <list>
#include "FrameWindow.h"

class CField;
class CCharacter;
class CEnemyPartyWindow;
class CPlayerPartyWindow;
//-----------------------------------------------------------------------------
// CDisplayManager
//-----------------------------------------------------------------------------
class CDisplayManager
{
protected:
	// VXe
	std::list<CFrameWindow *> m_lstWnd;		// \ǗXg
	CFrameWindow *m_pActiveWnd;				// ANeBu(L[͎)EBhE

	// EBhE
	CEnemyPartyWindow	*m_pEnemyPtWnd;		// Gp[eBEBhE

	CPlayerPartyWindow	*m_pPartyWnd;		// p[eB\EBhE
	CField				*m_pField;			// tB[h(Q)
	CEnemy				*m_pEnemyParty[BATTLE_ENEMY_COUNT_MAX];		// Gp[eB(Q)
	int					m_nEnemyCount;		// G̐


public:
	CDisplayManager(void);
	virtual ~CDisplayManager(void);

	BOOL Initialize( CCharacter **pPlayerParty, CEnemy **pEnemyParty, int nEnemyCount, CField *pField );
	void FrameMove( void );		// XV
	void Render( void );		// `
};

