//=============================================================================
// EnemyPartyWindow.cpp
//=============================================================================
#include <map>
#include "Stdinc.h"
#include "EnemyPartyWindow.h"
#include "MsgWindow.h"
#include "Enemy.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEnemyPartyWindow::CEnemyPartyWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEnemyPartyWindow::~CEnemyPartyWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CEnemyPartyWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CEnemy **pEnemyParty, int nEnemyCount )
{
	// |C^ۑ
	memcpy( m_pEnemy, pEnemyParty, sizeof(m_pEnemy) );
	m_nEnemyCount = nEnemyCount;

	return CMsgWindow::Create( iPosX, iPosY, iWidth, iHeight );
}
//-----------------------------------------------------------------------------
// FrameMove
// \XV
//
// ToDo: Gp[eBXg̍XV͖t[łȂėǂ͂
//       퓬WbN ړ
//-----------------------------------------------------------------------------
void CEnemyPartyWindow::FrameMove( void )
{
	using namespace std;

	typedef struct {
		int			nCount;	// ID̓G
		const char*	lpzName;	// O
	}stEnemyListInfo;

	map<int, stEnemyListInfo*> mapItem;
	map<int, stEnemyListInfo*>::iterator itlMap;

	// 
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), "" ); 
	}
	// GO擾
	for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
	{
		// ŏ炢Ȃ ł牽Ȃ
		if ( !m_pEnemy[iCnt] || m_pEnemy[iCnt]->m_nHP <= 0 )
			continue;

		// ID͂łɑ݂邩

		itlMap = mapItem.find( m_pEnemy[iCnt]->m_nID );
		if ( itlMap == mapItem.end() )
		{	// ݂Ȃ  ǉ
			stEnemyListInfo *pInfo = new stEnemyListInfo;
			pInfo->nCount = 1;
			pInfo->lpzName = m_pEnemy[iCnt]->m_szName;

			mapItem.insert(pair<int, stEnemyListInfo*>( m_pEnemy[iCnt]->m_nID , pInfo));
		}
		else 
		{	// ݂  XV
			(itlMap->second)->nCount ++;
		}
	}
	// XV폜
	int iLineCount = 0;
	for( itlMap = mapItem.begin(); itlMap != mapItem.end(); itlMap++ )
	{
		stEnemyListInfo *pInfo = (itlMap->second);

		if ( pInfo->nCount == 1 )
		{	// 1C
			strcpy_s( m_szDisplayMsg[iLineCount], pInfo->lpzName );
		}
		else
		{	// C
			sprintf_s( m_szDisplayMsg[iLineCount], "%s %d", pInfo->lpzName, pInfo->nCount );
		}

		++ iLineCount;
		delete (itlMap->second);
	}
}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEnemyPartyWindow::Render( void )
{
	// x[XNX`
	CMsgWindow::Render();
}
