//=============================================================================
// Manipulator.h
//=============================================================================
#pragma once

//-----------------------------------------------------------------------------
// CManipulator
//-----------------------------------------------------------------------------
class CManipulator
{
protected:
	char m_szKeyBuf[ 256 ];
	BOOL m_bShift;

public:
	CManipulator(void);
	virtual ~CManipulator(void);

	void CheckKeyState( void )
	{	GetHitKeyStateAll( m_szKeyBuf );	}

	BOOL IsKeyPushed( int nKeyCode ) const
	{	return m_szKeyBuf[nKeyCode];	};
	BOOL IsShift( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LSHIFT] || m_szKeyBuf[KEY_INPUT_RSHIFT];	};
	BOOL IsAlt( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LALT] || m_szKeyBuf[KEY_INPUT_RALT];	};
	BOOL IsCtr( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LCONTROL] || m_szKeyBuf[KEY_INPUT_RCONTROL];	};
};
