//=============================================================================
// Main.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleSystem.h"

long FAR PASCAL HookDxLibMessage( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );
//-----------------------------------------------------------------------------
// WinMain
//-----------------------------------------------------------------------------
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{
	// VXe̐ݒ
	SetOutApplicationLogValidFlag(FALSE);
	SetAlwaysRunFlag( TRUE );

	// `֌W̐ݒ
	SetUse3DFlag( FALSE );
	SetMouseDispFlag( FALSE );					// }EX\
	SetDrawScreen( DX_SCREEN_BACK );

	// EBhE̐ݒ
	ChangeWindowMode( TRUE );					// Window[h
	SetWindowStyleMode( 5 ) ;
	SetMainWindowText( "proto01" );
	SetWindowSizeExtendRate( 2.0f );
	SetGraphMode(CANVAS_WIDTH, CANVAS_HEIGHT, 32);

	// DXCu
	if( DxLib_Init() == -1 )
	{
		return -1;
	}

	// tHg̐ݒ
	SetFontSize(DISPLAY_MESSAGE_FONT_SIZE);
	SetFontThickness( 1 );
	SetFontSpace( -1 );
	ChangeFont("lr SVbN");

	// VXe
	CBattleSystem *pSystem = CBattleSystem::GetInstance();
	pSystem->Initialize();

	// EBhEbZ[W̃tbN
	SetHookWinProc( HookDxLibMessage ) ;

	// C[v
	while(!ProcessMessage())
	{
		// t[XV
		pSystem->FrameMove();

		// `
		ClearDrawScreen();
		pSystem->Render();

		// Present
		ScreenFlip();
	}

	// I
	DxLib_End();

	return 0;

}
//-----------------------------------------------------------------------------
// HookDxLibMessage
// WindowbZ[WtbN
//-----------------------------------------------------------------------------
long FAR PASCAL HookDxLibMessage( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
	case WM_USER+100:
		printfDx( "M\n" );
		break;
	}
	return 0;
}
